org.apache.commons.math.distribution

## Class ChiSquaredDistributionImpl

- java.lang.Object
- - org.apache.commons.math.distribution.AbstractDistribution
  - - org.apache.commons.math.distribution.AbstractContinuousDistribution
    - - org.apache.commons.math.distribution.ChiSquaredDistributionImpl

- All Implemented Interfaces:
    java.io.Serializable, ChiSquaredDistribution, ContinuousDistribution, Distribution, HasDensity<java.lang.Double>

      public class ChiSquaredDistributionImpl
      extends AbstractContinuousDistribution
      implements ChiSquaredDistribution, java.io.Serializable

  The default implementation of `ChiSquaredDistribution`
  Version:
    $Revision: 1054524 $ $Date: 2011-01-03 05:59:18 +0100 (lun. 03 janv. 2011) $
  See Also:
    Serialized Form

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static double` | `DEFAULT_INVERSE_ABSOLUTE_ACCURACY` Default inverse cumulative probability accuracy
    `private GammaDistribution` | `gamma` Internal Gamma distribution.
    `private static long` | `serialVersionUID` Serializable version identifier
    `private double` | `solverAbsoluteAccuracy` Inverse cumulative probability accuracy

    - ### Fields inherited from class org.apache.commons.math.distribution.AbstractContinuousDistribution

      `randomData`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `ChiSquaredDistributionImpl(double df)` Create a Chi-Squared distribution with the given degrees of freedom.
    `ChiSquaredDistributionImpl(double df, double inverseCumAccuracy)` Create a Chi-Squared distribution with the given degrees of freedom and inverse cumulative probability accuracy.
    `ChiSquaredDistributionImpl(double df, GammaDistribution g)` Deprecated. as of 2.1 (to avoid possibly inconsistent state, the "GammaDistribution" will be instantiated internally)

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `double` | `cumulativeProbability(double x)` For this distribution, X, this method returns P(X < x).
    `double` | `density(double x)` Return the probability density for a particular point.
    `double` | `density(java.lang.Double x)` Deprecated.
    `double` | `getDegreesOfFreedom()` Access the degrees of freedom.
    `protected double` | `getDomainLowerBound(double p)` Access the domain value lower bound, based on `p`, used to bracket a CDF root.
    `protected double` | `getDomainUpperBound(double p)` Access the domain value upper bound, based on `p`, used to bracket a CDF root.
    `protected double` | `getInitialDomain(double p)` Access the initial domain value, based on `p`, used to bracket a CDF root.
    `double` | `getNumericalMean()` Returns the mean of the distribution.
    `double` | `getNumericalVariance()` Returns the variance of the distribution.
    `protected double` | `getSolverAbsoluteAccuracy()` Return the absolute accuracy setting of the solver used to estimate inverse cumulative probabilities.
    `double` | `getSupportLowerBound()` Returns the lower bound of the support for the distribution.
    `double` | `getSupportUpperBound()` Returns the upper bound for the support for the distribution.
    `double` | `inverseCumulativeProbability(double p)` For this distribution, X, this method returns the critical point x, such that P(X < x) = `p`.
    `void` | `setDegreesOfFreedom(double degreesOfFreedom)` Deprecated. as of 2.1 (class will become immutable in 3.0)
    `private void` | `setDegreesOfFreedomInternal(double degreesOfFreedom)` Modify the degrees of freedom.
    `void` | `setGamma(GammaDistribution g)` Deprecated. as of 2.1 (class will become immutable in 3.0)
    `private void` | `setGammaInternal(GammaDistribution g)` Modify the underlying gamma distribution.

    - ### Methods inherited from class org.apache.commons.math.distribution.AbstractContinuousDistribution

      `reseedRandomGenerator, sample, sample`

    - ### Methods inherited from class org.apache.commons.math.distribution.AbstractDistribution

      `cumulativeProbability`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface org.apache.commons.math.distribution.Distribution

      `cumulativeProbability`

- - ### Field Detail

    - #### DEFAULT_INVERSE_ABSOLUTE_ACCURACY

          public static final double DEFAULT_INVERSE_ABSOLUTE_ACCURACY

      Default inverse cumulative probability accuracy
      Since:
        2.1
      See Also:
        Constant Field Values

    - #### serialVersionUID

          private static final long serialVersionUID

      Serializable version identifier
      See Also:
        Constant Field Values

    - #### gamma

          private GammaDistribution gamma

      Internal Gamma distribution.

    - #### solverAbsoluteAccuracy

          private final double solverAbsoluteAccuracy

      Inverse cumulative probability accuracy

  - ### Constructor Detail

    - #### ChiSquaredDistributionImpl

          public ChiSquaredDistributionImpl(double df)

      Create a Chi-Squared distribution with the given degrees of freedom.
      Parameters:
        `df` - degrees of freedom.

    - #### ChiSquaredDistributionImpl

          @Deprecated
          public ChiSquaredDistributionImpl(double df,
                                               GammaDistribution g)

      Deprecated. as of 2.1 (to avoid possibly inconsistent state, the "GammaDistribution" will be instantiated internally)
      Create a Chi-Squared distribution with the given degrees of freedom.
      Parameters:
        `df` - degrees of freedom.
        `g` - the underlying gamma distribution used to compute probabilities.
      Since:
        1.2

    - #### ChiSquaredDistributionImpl

          public ChiSquaredDistributionImpl(double df,
                                    double inverseCumAccuracy)

      Create a Chi-Squared distribution with the given degrees of freedom and inverse cumulative probability accuracy.
      Parameters:
        `df` - degrees of freedom.
        `inverseCumAccuracy` - the maximum absolute error in inverse cumulative probability estimates (defaults to `DEFAULT_INVERSE_ABSOLUTE_ACCURACY`)
      Since:
        2.1

  - ### Method Detail

    - #### setDegreesOfFreedom

          @Deprecated
          public void setDegreesOfFreedom(double degreesOfFreedom)

      Deprecated. as of 2.1 (class will become immutable in 3.0)
      Modify the degrees of freedom.
      Specified by:
        `setDegreesOfFreedom` in interface `ChiSquaredDistribution`
      Parameters:
        `degreesOfFreedom` - the new degrees of freedom.

    - #### setDegreesOfFreedomInternal

          private void setDegreesOfFreedomInternal(double degreesOfFreedom)

      Modify the degrees of freedom.
      Parameters:
        `degreesOfFreedom` - the new degrees of freedom.

    - #### getDegreesOfFreedom

          public double getDegreesOfFreedom()

      Access the degrees of freedom.
      Specified by:
        `getDegreesOfFreedom` in interface `ChiSquaredDistribution`
      Returns:
        the degrees of freedom.

    - #### density

          @Deprecated
          public double density(java.lang.Double x)

      Deprecated.
      Return the probability density for a particular point.
      Specified by:
        `density` in interface `ChiSquaredDistribution`
      Specified by:
        `density` in interface `HasDensity<java.lang.Double>`
      Parameters:
        `x` - The point at which the density should be computed.
      Returns:
        The pdf at point x.

    - #### density

          public double density(double x)

      Return the probability density for a particular point.
      Overrides:
        `density` in class `AbstractContinuousDistribution`
      Parameters:
        `x` - The point at which the density should be computed.
      Returns:
        The pdf at point x.
      Since:
        2.1

    - #### cumulativeProbability

          public double cumulativeProbability(double x)
                                       throws MathException

      For this distribution, X, this method returns P(X < x).
      Specified by:
        `cumulativeProbability` in interface `Distribution`
      Parameters:
        `x` - the value at which the CDF is evaluated.
      Returns:
        CDF for this distribution.
      Throws:
        `MathException` - if the cumulative probability can not be computed due to convergence or other numerical errors.

    - #### inverseCumulativeProbability

          public double inverseCumulativeProbability(double p)
                                              throws MathException

      For this distribution, X, this method returns the critical point x, such that P(X < x) = `p`.

      Returns 0 for p=0 and `Double.POSITIVE_INFINITY` for p=1.

      Specified by:
        `inverseCumulativeProbability` in interface `ContinuousDistribution`
      Overrides:
        `inverseCumulativeProbability` in class `AbstractContinuousDistribution`
      Parameters:
        `p` - the desired probability
      Returns:
        x, such that P(X < x) = `p`
      Throws:
        `MathException` - if the inverse cumulative probability can not be computed due to convergence or other numerical errors.
        `java.lang.IllegalArgumentException` - if `p` is not a valid probability.

    - #### getDomainLowerBound

          protected double getDomainLowerBound(double p)

      Access the domain value lower bound, based on `p`, used to bracket a CDF root. This method is used by `inverseCumulativeProbability(double)` to find critical values.
      Specified by:
        `getDomainLowerBound` in class `AbstractContinuousDistribution`
      Parameters:
        `p` - the desired probability for the critical value
      Returns:
        domain value lower bound, i.e. P(X < lower bound) < `p`

    - #### getDomainUpperBound

          protected double getDomainUpperBound(double p)

      Access the domain value upper bound, based on `p`, used to bracket a CDF root. This method is used by `inverseCumulativeProbability(double)` to find critical values.
      Specified by:
        `getDomainUpperBound` in class `AbstractContinuousDistribution`
      Parameters:
        `p` - the desired probability for the critical value
      Returns:
        domain value upper bound, i.e. P(X < upper bound) > `p`

    - #### getInitialDomain

          protected double getInitialDomain(double p)

      Access the initial domain value, based on `p`, used to bracket a CDF root. This method is used by `inverseCumulativeProbability(double)` to find critical values.
      Specified by:
        `getInitialDomain` in class `AbstractContinuousDistribution`
      Parameters:
        `p` - the desired probability for the critical value
      Returns:
        initial domain value

    - #### setGamma

          @Deprecated
          public void setGamma(GammaDistribution g)

      Deprecated. as of 2.1 (class will become immutable in 3.0)
      Modify the underlying gamma distribution. The caller is responsible for insuring the gamma distribution has the proper parameter settings.
      Parameters:
        `g` - the new distribution.
      Since:
        1.2 made public

    - #### setGammaInternal

          private void setGammaInternal(GammaDistribution g)

      Modify the underlying gamma distribution. The caller is responsible for insuring the gamma distribution has the proper parameter settings.
      Parameters:
        `g` - the new distribution.
      Since:
        1.2 made public

    - #### getSolverAbsoluteAccuracy

          protected double getSolverAbsoluteAccuracy()

      Return the absolute accuracy setting of the solver used to estimate inverse cumulative probabilities.
      Overrides:
        `getSolverAbsoluteAccuracy` in class `AbstractContinuousDistribution`
      Returns:
        the solver absolute accuracy
      Since:
        2.1

    - #### getSupportLowerBound

          public double getSupportLowerBound()

      Returns the lower bound of the support for the distribution. The lower bound of the support is always 0 no matter the degrees of freedom.
      Returns:
        lower bound of the support (always 0)
      Since:
        2.2

    - #### getSupportUpperBound

          public double getSupportUpperBound()

      Returns the upper bound for the support for the distribution. The upper bound of the support is always positive infinity no matter the degrees of freedom.
      Returns:
        upper bound of the support (always Double.POSITIVE_INFINITY)
      Since:
        2.2

    - #### getNumericalMean

          public double getNumericalMean()

      Returns the mean of the distribution. For `k` degrees of freedom, the mean is `k`
      Returns:
        the mean
      Since:
        2.2

    - #### getNumericalVariance

          public double getNumericalVariance()

      Returns the variance of the distribution. For `k` degrees of freedom, the variance is `2 * k`
      Returns:
        the variance
      Since:
        2.2

Copyright (c) 2003-2013 Apache Software Foundation